const int Num = 8;
  // ===============================================================
  // ==========  test MOTORI prima a SX poi a DX =================
  // ===============================================================
  
// Motori
const int Pin_OUT_L = 5;     // PWM Motore sinistro
const int Pin_OUT_R = 3;     // PWM Motore destro

// Sensori
#define AND 0
#define MOR 1
#define LUC 0
#define MIC 0

#if AND == 1
const int sharpL_pin = A1;   // SHARP SINISTRO
const int sharpR_pin = A0;   // SHARP DESTRO
const int battery_pin = A2;  // Batteria
const int cny70L_pin = A5;    // CNY70 SINISTRO
const int cny70R_pin = A4;    // CNY70 DESTRO
const float sVL = 1.275;
const float sVR = 1;
#elif MOR == 1 //??????????????????
const int sharpL_pin = A1;   // SHARP SINISTRO
const int sharpR_pin = A0;   // SHARP DESTRO
const int battery_pin = A2;  // Batteria
const int cny70L_pin = A5;    // CNY70 SINISTRO
const int cny70R_pin = A4;    // CNY70 DESTRO
const float sVL = 1;
const float sVR = 1;
#elif LUC == 1
const int sharpL_pin = A2;   // SHARP SINISTRO
const int sharpR_pin = A3;   // SHARP DESTRO
const int battery_pin = A0;  // Batteria
const int cny70L_pin = A1;    // CNY70 SINISTRO
const int cny70R_pin = A4;    // CNY70 DESTRO
const float sVL = 1.25;
const float sVR = 1;
#elif MIC == 1
const int sharpL_pin = A4;   // SHARP SINISTRO
const int sharpR_pin = A5;   // SHARP DESTRO
const int battery_pin = A0;  // Batteria
const int cny70L_pin = A2;    // CNY70 SINISTRO
const int cny70R_pin = A1;    // CNY70 DESTRO
const float sVL = 1.1;
const float sVR = 1;
#endif

unsigned int val_sharpL = 0;
unsigned int val_sharpR = 0;
unsigned int arr_sharpL[10];
unsigned int arr_sharpR[10];
unsigned int val_cny70L = 0;
unsigned int val_cny70R = 0;
unsigned int val_battery = 0;
unsigned int i = 0;

unsigned long now, nextPrint;

void setup() {
  pinMode(Pin_OUT_L, OUTPUT);  
  pinMode(Pin_OUT_R, OUTPUT);
  analogWrite(Pin_OUT_L, 100);  
  delay(1000);
  analogWrite(Pin_OUT_L, 0);  
  analogWrite(Pin_OUT_R, 100);
  delay(1000);
  analogWrite(Pin_OUT_R, 0);
  /*
  for (int j = 0; j < 10; j++) {
    arr_sharpL[j] = analogRead(sharpL_pin);
    arr_sharpR[j] = analogRead(sharpR_pin);
  }*/

  nextPrint = millis();

  Serial.begin(9600);
  
  //analogWrite(Pin_OUT_L,100);
  //analogWrite(Pin_OUT_R,100);
  //delay(1000);
  //analogWrite(Pin_OUT_L,0);
  //analogWrite(Pin_OUT_R,0);
}

// the loop routine runs over and over again forever:
void loop()
{ 
  // Lettura valori dai sensori
  
  val_battery = val_sharpL = val_sharpR = 0;
  val_cny70L = val_cny70R = 0;
  for (int j = 0; j < Num; j++) {
    val_battery += analogRead(battery_pin);
    delayMicroseconds(100);
    val_cny70L += analogRead(cny70L_pin);
    delayMicroseconds(100);
    val_cny70R += analogRead(cny70R_pin);
    delayMicroseconds(100);
    val_sharpL += analogRead(sharpL_pin);
    delayMicroseconds(100);
    val_sharpR += analogRead(sharpR_pin);
    delayMicroseconds(100);
  }
  val_battery /= Num;
  val_sharpL /= Num;
  val_sharpR /= Num;
  val_cny70L /= Num;
  val_cny70R /= Num;
  
  /*arr_sharpL[i] = analogRead(sharpL_pin);
  arr_sharpR[i] = analogRead(sharpR_pin);
  i++;
  if (!(i % 10)) {
    i = 0;
  }
  val_sharpL = 0;
  val_sharpR = 0;
  for (int j = 0; j < 10; j++) {
    val_sharpL += arr_sharpL[j];
    val_sharpR += arr_sharpR[j];
  }
  val_sharpL /= 10;
  val_sharpR /= 10;*/

  now = millis();
  if (now > nextPrint) {
    nextPrint = now + 500;

    Serial.print("SHARP Left: ");
    Serial.print(val_sharpL);

    Serial.print(" - SHARP Right: ");
    Serial.print(val_sharpR);
    
    Serial.print(" CNY70 Left: ");
    Serial.print(val_cny70L);
  
    Serial.print(" - CNY70 Right: ");
    Serial.print(val_cny70R);
    
    Serial.print(" Battery: ");
    Serial.println(val_battery);
  }
}

